AsArrayTypeSerializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.jsontype.impl

## Class AsArrayTypeSerializer

- java.lang.Object
- - org.codehaus.jackson.map.TypeSerializer
  - - org.codehaus.jackson.map.jsontype.impl.TypeSerializerBase
    - - org.codehaus.jackson.map.jsontype.impl.AsArrayTypeSerializer

- Direct Known Subclasses:
    AsPropertyTypeSerializer

      public class AsArrayTypeSerializer
      extends TypeSerializerBase

  Type serializer that will embed type information in an array, as the first element, and actual value as the second element.
  Since:
    1.5
  Author:
    tatu

- - ### Field Summary

    - ### Fields inherited from class org.codehaus.jackson.map.jsontype.impl.TypeSerializerBase

      `_idResolver, _property`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsArrayTypeSerializer(TypeIdResolver idRes, BeanProperty property)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonTypeInfo.As` | `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
    `void` | `writeTypePrefixForArray(Object value, JsonGenerator jgen)` Method called to write initial part of type information for given value, when it will be output as JSON Array value (not as JSON Object or scalar).
    `void` | `writeTypePrefixForArray(Object value, JsonGenerator jgen, Class<?> type)` Alternative version of the prefix-for-array method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator jgen)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar).
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator jgen, Class<?> type)` Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypePrefixForScalar(Object value, JsonGenerator jgen)` Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array).
    `void` | `writeTypePrefixForScalar(Object value, JsonGenerator jgen, Class<?> type)` Alternative version of the prefix-for-scalar method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
    `void` | `writeTypeSuffixForArray(Object value, JsonGenerator jgen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypeSuffixForScalar(java.lang.Object, org.codehaus.jackson.JsonGenerator)`.
    `void` | `writeTypeSuffixForObject(Object value, JsonGenerator jgen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, org.codehaus.jackson.JsonGenerator)`.
    `void` | `writeTypeSuffixForScalar(Object value, JsonGenerator jgen)` Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, org.codehaus.jackson.JsonGenerator)`.

    - ### Methods inherited from class org.codehaus.jackson.map.jsontype.impl.TypeSerializerBase

      `getPropertyName, getTypeIdResolver`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AsArrayTypeSerializer

          public AsArrayTypeSerializer(TypeIdResolver idRes,
                               BeanProperty property)

  - ### Method Detail

    - #### getTypeInclusion

          public JsonTypeInfo.As getTypeInclusion()

      Description copied from class: `TypeSerializer`
      Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
      Specified by:
        `getTypeInclusion` in class `TypeSerializerBase`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar). This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Specified by:
        `writeTypePrefixForObject` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `jgen` - Generator to use for writing type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator jgen,
                                      Class<?> type)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForObject` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForArray

          public void writeTypePrefixForArray(Object value,
                                     JsonGenerator jgen)
                                       throws IOException,
                                              JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Array value (not as JSON Object or scalar). This means that context after call must be JSON Array, that is, there must be an open START_ARRAY to write contents in.
      Specified by:
        `writeTypePrefixForArray` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `jgen` - Generator to use for writing type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForArray

          public void writeTypePrefixForArray(Object value,
                                     JsonGenerator jgen,
                                     Class<?> type)
                                       throws IOException,
                                              JsonProcessingException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-array method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForArray` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForScalar

          public void writeTypePrefixForScalar(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as scalar JSON value (not as JSON Object or Array). This means that the context after call can not be that of JSON Object; it may be Array or root context.
      Specified by:
        `writeTypePrefixForScalar` in class `TypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `jgen` - Generator to use for writing type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypePrefixForScalar

          public void writeTypePrefixForScalar(Object value,
                                      JsonGenerator jgen,
                                      Class<?> type)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-scalar method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForScalar` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypeSuffixForObject

          public void writeTypeSuffixForObject(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForObject(java.lang.Object, org.codehaus.jackson.JsonGenerator)`. It needs to write closing END_OBJECT marker, and any other decoration that needs to be matched.
      Specified by:
        `writeTypeSuffixForObject` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypeSuffixForArray

          public void writeTypeSuffixForArray(Object value,
                                     JsonGenerator jgen)
                                       throws IOException,
                                              JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypeSuffixForScalar(java.lang.Object, org.codehaus.jackson.JsonGenerator)`. It needs to write closing END_ARRAY marker, and any other decoration that needs to be matched.
      Specified by:
        `writeTypeSuffixForArray` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### writeTypeSuffixForScalar

          public void writeTypeSuffixForScalar(Object value,
                                      JsonGenerator jgen)
                                        throws IOException,
                                               JsonProcessingException

      Description copied from class: `TypeSerializer`
      Method called after value has been serialized, to close any scopes opened by earlier matching call to `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, org.codehaus.jackson.JsonGenerator)`. Actual action to take may depend on various factors, but has to match with action `TypeSerializer.writeTypePrefixForScalar(java.lang.Object, org.codehaus.jackson.JsonGenerator)` did (close array or object; or do nothing).
      Specified by:
        `writeTypeSuffixForScalar` in class `TypeSerializer`
      Throws:
        `IOException`
        `JsonProcessingException`